﻿using System.Data;
using System.Data.Common;
using System.Data.Odbc;
using System.Reflection.Metadata;

namespace ODBCConn
{
    internal class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("");
            Console.WriteLine("#### MasterSlave Start ####");

            string connectionString = "Driver={OceanBase ODBC 2.0 Driver};Server=192.168.1.205;Port=2883;Database=UniIntegrationWeb_platform;User=UniIntegrationWeb_platform@oracle_tenant2;Password=Unionnet17931#;";
            OceanBaseDatabase oceanBaseDB = new OceanBaseDatabase(connectionString);

            // 执行查询
            string query = "SELECT * FROM ORDERS";
            DataTable result = oceanBaseDB.ExecuteQuery(query);


            // 调用存储过程
            string procedureName = "Proc_Test_table_return";
            OdbcParameter parameter1 = new OdbcParameter("p_col1", "");
            OdbcParameter parameter2 = new OdbcParameter("p_xx1", "");
            //parameter2.Direction = ParameterDirection.Output;
            //parameter2.DbType = OdbcType.RefCursor;
            OdbcParameter parameter3 = new OdbcParameter("p_xx2", "");
            //oceanBaseDB.ExecuteStoredProcedure(procedureName, parameter1, parameter2, parameter3);


            oceanBaseDB.ExecuteStoredProcedure("Proc_Test_table");


            Console.WriteLine("#### MasterSlave Start ####");


            // 调用带结果的存储过程
            DataTable result1 = oceanBaseDB.ExecuteStoredProcedureWithResult(procedureName, parameter1, parameter2, parameter3);


            Console.WriteLine("#### MasterSlave Start ####");
        }

    }


    public class OceanBaseDatabase
    {
        private string connectionString;

        public OceanBaseDatabase(string connectionString)
        {
            this.connectionString = connectionString;
        }

        public void ExecuteNonQuery(string query)
        {
            using (OdbcConnection connection = new OdbcConnection(connectionString))
            {
                connection.Open();
                using (OdbcCommand command = new OdbcCommand(query, connection))
                {
                    command.ExecuteNonQuery();
                }
            }
        }

        public DataTable ExecuteQuery(string query)
        {
            DataTable dataTable = new DataTable();
            using (OdbcConnection connection = new OdbcConnection(connectionString))
            {
                connection.Open();
                using (OdbcCommand command = new OdbcCommand(query, connection))
                {
                    using (OdbcDataAdapter adapter = new OdbcDataAdapter(command))
                    {
                        adapter.Fill(dataTable);
                    }
                }
            }
            return dataTable;
        }

        public void ExecuteStoredProcedure(string procedureName, params OdbcParameter[] parameters)
        {
            using (OdbcConnection connection = new OdbcConnection(connectionString))
            {
                connection.Open();
                using (OdbcCommand command = new OdbcCommand(procedureName, connection))
                {
                    command.CommandType = CommandType.StoredProcedure;
                    if (parameters != null)
                    {
                        command.Parameters.AddRange(parameters);
                    }
                    command.ExecuteNonQuery();
                }
            }
        }

        public DataTable ExecuteStoredProcedureWithResult(string procedureName, params OdbcParameter[] parameters)
        {
            DataTable dataTable = new DataTable();
            using (OdbcConnection connection = new OdbcConnection(connectionString))
            {
                connection.Open();
                using (OdbcCommand command = new OdbcCommand(procedureName, connection))
                {
                    command.CommandType = CommandType.StoredProcedure;
                    if (parameters != null)
                    {
                        command.Parameters.AddRange(parameters);
                    }
                    using (OdbcDataAdapter adapter = new OdbcDataAdapter(command))
                    {
                        adapter.Fill(dataTable);
                    }
                }
            }
            return dataTable;
        }

    }
}